<html>
<! QueryRelativeBFILE.php                                              >
<! Rozdzia 8., Oracle Database 11g. Programowanie w jzyku PL/SQL     >
<! Michael McLaughlin                                                  >
<!                                                                     >
<! Ten skrypt ilustruje przesyanie pliku, przenoszenie przesanego    >
<! pliku, zapisywanie jego zawartoci w kolumnie typu CLOB bazy Oracle >
<! za pomoc skadowanej procedury PL/SQL, dostp do                   >
<! danych zapisanych w bazie i wywietlanie strony.                    >
<head>
<title>
  Rozdzia 8. QueryRelativeBFILE.php
</title>
<style>
.e {background-color: #ccccff; font-weight: bold; color: #000000;}
.v {background-color: #cccccc; color: #000000;}
</style>
</head>
<body>
<?php
  // Deklaracja zmiennych wejciowych.
  (isset($_GET['id']))    ? $id = (int) $_GET['id'] : $id = 1021;

  // Wywoanie funkcji lokalnej.
  query_insert($id);

  // Sprawdzanie wynikw po wstawieniu danych.
  function query_insert($id)
  {
    // Sprawdzanie moliwoci nawizanie poczenie z baz danych.
    if ($c = @oci_connect("plsql","plsql","orcl"))
    {
      // Instrukcja SELECT jzyka SQL zwracajca obiekt CLOB.
      $stmt = "SELECT   item_title
               ,        item_desc
               ,        get_bfilename('ITEM','ITEM_PHOTO','ITEM_ID',:id)
               FROM     item
               WHERE    item_id = :id";

      // Przetwarzanie zapytania przy uyciu poczenia.
      $s = oci_parse($c,$stmt);

      // Wizanie zmiennych z kodu PHP z typami biblioteki OCI.
      oci_bind_by_name($s,':id',$id);

      // Wykonywanie instrukcji jzyka PL/SQL.
      if (oci_execute($s))
      {
        // Zwracanie deskryptora typu LOB.
        while (oci_fetch($s))
        {
          for ($i = 1;$i <= oci_num_fields($s);$i++)
            if (is_object(oci_result($s,$i)))
            {
              if ($size = oci_result($s,$i)->size())
                if (oci_field_type($s,$i) == 'CLOB')
                  $data = oci_result($s,$i)->read($size);
              else
                $data = "&nbsp;";
            }
            else
            {
              if (oci_field_is_null($s,$i))
                $title = "&nbsp;";
              else
                if (substr(oci_result($s,$i),0,1) == '/')
                  $photo = oci_result($s,$i);
                else
                  $title = oci_result($s,$i);
            }

        } // Koniec ptli while(oci_fetch($s)).

        // Zwalnianie zasobw.
        oci_free_statement($s);

        // Formatowanie tabeli HTML, aby wywietli w niej zdjcie z kolumny BLOB i opis z kolumny CLOB.
        $out = '<table border="1" cellpadding="5" cellspacing="0">';
        $out .= '<tr>';
        $out .= '<td align="center" class="e">'.$title.'</td>';
        $out .= '</tr>';
        $out .= '<tr><td class="v">';
        $out .= '<div>';
        $out .= '<div style="margin-right:5px;float:left">';
        $out .= '<img src="'.$photo.'">';
        $out .= '</div>';
        $out .= '<div style="position=relative;">'.$data.'</div>';
        $out .= '</div>';
        $out .= '</td></tr>';
        $out .= '</table>';
      }

      // Wywietlanie tabeli HTML.
      print $out;

      // Zamknicie poczenia z baz danych.
      oci_close($c);
    }
    else
    {
      // Przypisanie bdu OCI i formatowanie cudzysoww oraz apostrofw.
      $errorMessage = oci_error();
      print htmlentities($errorMessage['message'])."<br />";
    }
  }
?>
</body>
</html>